#include "float.h"
#include "MyAI.h"

MyAI::MyAI(void){
    srand(time(NULL));
}

MyAI::~MyAI(void){}

// void MyAI::Name(const char* data[], char* response)
// {
// 	strcpy(response, "MyAI");
// }

// void MyAI::Version(const char* data[], char* response)
// {
// 	strcpy(response, "1.0.0");
// }

// void MyAI::Time_setting(const char* data[], char* response)//=2 time_setting 240 0 0
// {
// 	this->p1_time = stoi(data[2]);
// 	this->p2_time = stoi(data[2]);
// 	strcpy(response, "1");
// }

// void MyAI::Board_setting(const char* data[], char* response)
// {
// 	this->board_size = stoi(data[2]);
// 	this->p1_piece_num = stoi(data[3]);
// 	this->p2_piece_num = stoi(data[3]);
// 	strcpy(response, "1");
// }

void MyAI::Ini(const char* data[], char* response)
{
    // set color
    if(!strcmp(data[2], "1"))
    {
        this->color = P1;
    }
    else if(!strcmp(data[2], "2"))
    {
        this->color = P2;
    }

    char position[16];
    this->Init_board_state(position);
    //p2的棋子位置
    snprintf(response, 50, "%c%c %c%c %c%c %c%c %c%c %c%c %c%c %c%c", 
             position[0], position[1], position[2], position[3],
             position[4], position[5], position[6], position[7],
             position[8], position[9], position[10], position[11], 
             position[12], position[13], position[14], position[15]);
}

void MyAI::Get(const char* data[], char* response)
{
    // set dice & board
    char position[48]; // 3*16
    position[0] = '\0';
    snprintf(position, sizeof(position), "%s", data[0] + 4);
    this->Set_board(position);

    // generate move
    char move[50];
    this->Generate_move(move);
    snprintf(response, 50, "MOV:%s", move); 
}
void MyAI::Set( char* response){
	snprintf(response, 50, "SET:ABCD\r\n"); 
}

void MyAI::Exit(const char* data[], char* response)
{
    fprintf(stderr, "Bye~\n");
}

// *********************** AI FUNCTION *********************** //

void MyAI::Init_board_state(char* position)
{
    int order[PIECE_NUM] = {0, 1, 2, 3, 4, 5 , 6 , 7}; // A~H
    string p2_init_position = "4131211140302010";
    string p1_init_position = "1424344415253545";

    for(int i = 0; i < PIECE_NUM; i++)
    {
        if(this->color == P1)
        {
            position[order[i] * 2] = p1_init_position[i * 2];
            position[order[i] * 2 + 1] = p1_init_position[i * 2 + 1];
        }
        else if(this->color == P2)
        {
            position[order[i] * 2] = p2_init_position[i * 2];
            position[order[i] * 2 + 1] = p2_init_position[i * 2 + 1];
        }
    }
}

void MyAI::Set_board(char* position)
{
    memset(this->board, 0, sizeof(this->board));
	memset(this->piece_colors,'0',sizeof(this->piece_colors));
    memset(this->p2_exist, 1, sizeof(this->p2_exist));
    memset(this->p1_exist, 1, sizeof(this->p1_exist));
    this->p2_piece_num = PIECE_NUM;
    this->p1_piece_num = PIECE_NUM;

    int lost_piece_num = 0;
    for(int i = 0; i < PIECE_NUM * 2; i++)
    {
        int index = i * 3;

        // 如果棋子不存在，跳過 "99r" 並更新狀態
        if(position[index] == '9' && position[index + 1] == '9')
        {
            lost_piece_num++;
            // P1
            if(i < PIECE_NUM) 
            {
                this->p1_piece_num--;
                this->p1_exist[i] = 0;
            }
            // P2
            else 
            {
                this->p2_piece_num--;
                this->p2_exist[i - PIECE_NUM] = 0;
            }
        }
        // 1~8: P1 pieces; 9~16: P2 pieces
        else
        {
            this->board[position[index + 1] - '0'][position[index] - '0'] = i + 1;
            this->piece_colors[i] = position[index + 2];  // 設定棋子顏色
        }
    }

    // stderr board
    // this->Print_chessboard();
}

void MyAI::Print_chessboard()
{
    fprintf(stderr, "\n");
    // 0~7 represent P1 pieces; 8~15 represent P2 pieces
    for(int i = 0; i < BOARD_SIZE; i++)
    {
        fprintf(stderr, "<%d>   ", i + 1);
        for(int j = 0; j < BOARD_SIZE; j++)
        {
            if(this->board[i][j] == 0) fprintf(stderr, "0  ");
            else if(this->board[i][j] <= PIECE_NUM ) {
                fprintf(stderr, "%c  ", this->board[i][j] - 1 + 'A');
            }
            else fprintf(stderr, "%c  ", this->board[i][j] - 9 + 'a'); // 小寫代表敵方的棋子
        }
        fprintf(stderr, "\n");
    }
    fprintf(stderr, "\n     ");
    for (int i = 0; i < BOARD_SIZE; i++)
    {
        fprintf(stderr, "<%d>",  i + 1);
    }
    fprintf(stderr, "\n\n");
    fprintf(stderr, "The number of P1 pieces: %d\nThe number of P2 pieces: %d\n", this->p1_piece_num, this->p2_piece_num);
}

void MyAI::Generate_move(char* move)
{
    int result[100];
    memset(result, 0, sizeof(result));

    // get legal moves
    int move_count = this->get_legal_move(result);
    // for(int i = 0; i < move_count; i++)
    // {
    //     fprintf(stderr, "Piece: %d, Direction: %d\n", result[i * 2], result[i * 2 + 1]);
    // }
    if (move_count <= 0) {
        strcpy(move, "NO_MOVE"); 
        return;
    }
    // randomly choose a legal move
    int rand_move = rand() % move_count;
    int piece = result[rand_move * 2];

    // determine the direction of the move
    const char* direction;
    switch(result[rand_move * 2 + 1]) {
        case 0: direction = "NORTH"; break;
        case 1: direction = "SOUTH"; break;
        case 2: direction = "WEST"; break;
        case 3: direction = "EAST"; break;
        default: direction = "UNKNOWN"; break;
    }

    fprintf(stderr, "Result: ");

    snprintf(move, 50, "%c,%s", 'A' + piece - 1, direction);  // generate the new move string

    this->Make_move(piece, direction);
    fprintf(stderr, "MOV:%s\n", move);
}

// get all legal moves
int MyAI::get_legal_move(int* result)
{
    int src, dst[4];
    int move_count = 0;
    int result_count = 0;

    // iterate over all pieces
    for(int piece = 1; piece <= PIECE_NUM; ++piece)
    {
        // check if the piece is alive
        if(this->p1_exist[piece - 1])
        {
            move_count = this->referee(piece, dst);
            for(int i = 0; i < move_count; i++) 
            {
                result[result_count * 2] = piece;
                result[result_count * 2 + 1] = dst[i];
                result_count++;
            }
        }
    }

    return result_count;
}

// get possible moves of the piece
int MyAI::referee(int piece, int* dst)
{
    int src = -1;
    for(int i = 0; i < BOARD_SIZE; i++)
    {
        for(int j = 0; j < BOARD_SIZE; j++)
        {
            if(this->board[i][j] == piece)
            {
                src = i * BOARD_SIZE + j;
                break;
            }
        }
        if (src != -1) break;
    }

    if (src == -1) return 0; // 沒有找到該棋子

    int move_count = 0;
    int row = src / BOARD_SIZE;
    int col = src % BOARD_SIZE;
	char color = 'u';
    // check if the piece can move up
	//左邊逃跑
	if(row ==0 && col==0 && piece_colors[piece-1]=='B')
    {
        dst[move_count++] = 2;  // 0 represents "WEST"
    }
	//右邊逃跑
	if(row ==0 && col==BOARD_SIZE - 1 && piece_colors[piece-1]=='B')
    {
        dst[move_count++] = 3;  // 0 represents "EAST"
    }
    // 北方向
    if(row > 0 && (this->board[row - 1][col] == 0 || this->piece_colors[this->board[row - 1][col] - 1] == color))
    {
        dst[move_count++] = 0;  // 0 represents "NORTH"
    }

    // 南方向
    if(row < BOARD_SIZE - 1 && (this->board[row + 1][col] == 0 || this->piece_colors[this->board[row + 1][col] - 1] == color))
    {
        dst[move_count++] = 1;  // 1 represents "SOUTH"
    }

    // 西方向
    if(col > 0 && (this->board[row][col - 1] == 0 || this->piece_colors[this->board[row][col - 1] - 1] == color))
    {
        dst[move_count++] = 2;  // 2 represents "WEST"
    }

    // fprintf(stderr, "row: %d, col: %d\n", row, col);
    // fprintf(stderr, "%d %d\n", this->board[row][col + 1], this->piece_colors[this->board[row][col + 1] - 1]);
    // fprintf(stderr, "%d %d\n", this->board[row][col + 1] == 0, this->piece_colors[this->board[row][col + 1] - 1] == color);

    // 東方向
    if(col < BOARD_SIZE - 1 && (this->board[row][col + 1] == 0 || this->piece_colors[this->board[row][col + 1] - 1] == color))
    {
        dst[move_count++] = 3;  // 3 represents "EAST"
    }
    return move_count;
}

void MyAI::Make_move(const int piece, const char* direction)
{
    int src;
    for(int i = 0; i < BOARD_SIZE; i++)
    {
        for(int j = 0; j < BOARD_SIZE; j++)
        {
            if(this->board[i][j] == piece)
            {
                src = i * BOARD_SIZE + j;
                break;
            }
        }
    }

    int start_row = src / BOARD_SIZE;
    int start_col = src % BOARD_SIZE;
    int end_row = start_row;
    int end_col = start_col;

    // determine the end point based on the direction
    if(strcmp(direction, "NORTH") == 0) end_row--;
    else if(strcmp(direction, "SOUTH") == 0) end_row++;
    else if(strcmp(direction, "WEST") == 0) end_col--;
    else if(strcmp(direction, "EAST") == 0) end_col++;

    this->board[start_row][start_col] = 0;

    // there has another piece on the target square
    if(this->board[end_row][end_col] > 0)
    {
        if(this->board[end_row][end_col] <= PIECE_NUM)
        {
            this->p2_exist[this->board[end_row][end_col] - 1] = 0;
            this->p2_piece_num--;
        }
        else
        {
            this->p1_exist[this->board[end_row][end_col] - 7] = 0;
            this->p1_piece_num--;			
        }
    }
    this->board[end_row][end_col] = piece;
}