#ifndef MYAI_INCLUDED
#define MYAI_INCLUDED 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <string>

using std::stoi;
using std::string;

#define P1 0
#define P2 1
#define BOARD_SIZE 6
#define PIECE_NUM 8
#define COMMAND_NUM 7

class MyAI  
{
	const char* commands_name[COMMAND_NUM] = {
		"name",
		"version",
		"time_setting",
		"board_setting",
		"ini",
		"get",
		"exit"
	};
public:
	MyAI(void);
	~MyAI(void);

	// commands
	// void Name(const char* data[], char* response);
	// void Version(const char* data[], char* response);
	// void Time_setting(const char* data[], char* response);
	// void Board_setting(const char* data[], char* response);
	void Ini(const char* data[], char* response);
	void Set(char* response);
	void Get(const char* data[], char* response);
	void Exit(const char* data[], char* response);

private:
	bool p1_exist[PIECE_NUM], p2_exist[PIECE_NUM];
	int color;
	int p1_time, p2_time;
	int board_size;
	int dice;
	int board[BOARD_SIZE][BOARD_SIZE];
	int p1_piece_num, p2_piece_num;
	char piece_colors[PIECE_NUM * 2]; //0 ~7: p1, 8~15: p2

	// Board
	void Init_board_state(char* position);
	void Set_board(char* position);
	void Print_chessboard();
	void Generate_move(char* move);
	// void Make_move(const int piece, const int start_point, const int end_point);
	void Make_move(const int piece, const char* direction);
	int get_legal_move(int* result); 
	//int referee(int piece, int* src, int* dst);
	int referee(int piece,int* dst);
};

#endif